<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>CoglOnscreen: The Onscreen Framebuffer Interface</title>
<meta name="generator" content="DocBook XSL Stylesheets V1.78.1">
<link rel="home" href="index.html" title="Cogl 2.0 Reference Manual">
<link rel="up" href="cogl-framebuffer-apis.html" title="Framebuffers">
<link rel="prev" href="cogl-2.0-experimental-CoglFramebuffer---The-Framebuffer-Interface.html" title="CoglFramebuffer: The Framebuffer Interface">
<link rel="next" href="cogl-2.0-experimental-Offscreen-Framebuffers.html" title="Offscreen Framebuffers">
<meta name="generator" content="GTK-Doc V1.18.1 (XML mode)">
<link rel="stylesheet" href="style.css" type="text/css">
</head>
<body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF">
<table class="navigation" id="top" width="100%" summary="Navigation header" cellpadding="2" cellspacing="2">
<tr valign="middle">
<td><a accesskey="p" href="cogl-2.0-experimental-CoglFramebuffer---The-Framebuffer-Interface.html"><img src="left.png" width="24" height="24" border="0" alt="Prev"></a></td>
<td><a accesskey="u" href="cogl-framebuffer-apis.html"><img src="up.png" width="24" height="24" border="0" alt="Up"></a></td>
<td><a accesskey="h" href="index.html"><img src="home.png" width="24" height="24" border="0" alt="Home"></a></td>
<th width="100%" align="center">Cogl 2.0 Reference Manual</th>
<td><a accesskey="n" href="cogl-2.0-experimental-Offscreen-Framebuffers.html"><img src="right.png" width="24" height="24" border="0" alt="Next"></a></td>
</tr>
<tr><td colspan="5" class="shortcuts">
<a href="#cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.synopsis" class="shortcut">Top</a>
                   | 
                  <a href="#cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.description" class="shortcut">Description</a>
</td></tr>
</table>
<div class="refentry">
<a name="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface"></a><div class="titlepage"></div>
<div class="refnamediv"><table width="100%"><tr>
<td valign="top">
<h2><span class="refentrytitle"><a name="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.top_of_page"></a>CoglOnscreen: The Onscreen Framebuffer Interface</span></h2>
<p>CoglOnscreen: The Onscreen Framebuffer Interface</p>
</td>
<td valign="top" align="right"></td>
</tr></table></div>
<div class="refsynopsisdiv">
<a name="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.synopsis"></a><h2>Synopsis</h2>
<pre class="synopsis">                    <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen">CoglOnscreen</a>;
<a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="returnvalue">CoglBool</span></a>            <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-is-onscreen" title="cogl_is_onscreen ()">cogl_is_onscreen</a>                    (<em class="parameter"><code><span class="type">void</span> *object</code></em>);
#define             <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#COGL-ONSCREEN:CAPS" title="COGL_ONSCREEN()">COGL_ONSCREEN</a>                       (X)

<a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="returnvalue">CoglOnscreen</span></a> *      <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-new" title="cogl_onscreen_new ()">cogl_onscreen_new</a>                   (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-The-Top-Level-Context.html#CoglContext" title="CoglContext"><span class="type">CoglContext</span></a> *context</code></em>,
                                                         <em class="parameter"><code><span class="type">int</span> width</code></em>,
                                                         <em class="parameter"><code><span class="type">int</span> height</code></em>);

<span class="returnvalue">void</span>                (<a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreenX11MaskCallback" title="CoglOnscreenX11MaskCallback ()">*CoglOnscreenX11MaskCallback</a>)      (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>,
                                                         <em class="parameter"><code><span class="type">uint32_t</span> event_mask</code></em>,
                                                         <em class="parameter"><code><span class="type">void</span> *user_data</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-x11-onscreen-set-foreign-window-xid" title="cogl_x11_onscreen_set_foreign_window_xid ()">cogl_x11_onscreen_set_foreign_window_xid</a>
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>,
                                                         <em class="parameter"><code><span class="type">uint32_t</span> xid</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreenX11MaskCallback" title="CoglOnscreenX11MaskCallback ()"><span class="type">CoglOnscreenX11MaskCallback</span></a> update</code></em>,
                                                         <em class="parameter"><code><span class="type">void</span> *user_data</code></em>);
<span class="returnvalue">uint32_t</span>            <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-x11-onscreen-get-window-xid" title="cogl_x11_onscreen_get_window_xid ()">cogl_x11_onscreen_get_window_xid</a>    (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>);
<span class="returnvalue">uint32_t</span>            <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-x11-onscreen-get-visual-xid" title="cogl_x11_onscreen_get_visual_xid ()">cogl_x11_onscreen_get_visual_xid</a>    (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>);

<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-win32-onscreen-set-foreign-window" title="cogl_win32_onscreen_set_foreign_window ()">cogl_win32_onscreen_set_foreign_window</a>
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>,
                                                         <em class="parameter"><code><span class="type">HWND</span> hwnd</code></em>);
<span class="returnvalue">HWND</span>                <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-win32-onscreen-get-window" title="cogl_win32_onscreen_get_window ()">cogl_win32_onscreen_get_window</a>      (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>);

<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-show" title="cogl_onscreen_show ()">cogl_onscreen_show</a>                  (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-hide" title="cogl_onscreen_hide ()">cogl_onscreen_hide</a>                  (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>);

<span class="returnvalue">void</span>                (<a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglFrameCallback" title="CoglFrameCallback ()">*CoglFrameCallback</a>)                (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>,
                                                         <em class="parameter"><code><span class="type">CoglFrameEvent</span> event</code></em>,
                                                         <em class="parameter"><code><span class="type">CoglFrameInfo</span> *info</code></em>,
                                                         <em class="parameter"><code><span class="type">void</span> *user_data</code></em>);
typedef             <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglFrameClosure" title="CoglFrameClosure">CoglFrameClosure</a>;
<a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglFrameClosure" title="CoglFrameClosure"><span class="returnvalue">CoglFrameClosure</span></a> *  <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-add-frame-callback" title="cogl_onscreen_add_frame_callback ()">cogl_onscreen_add_frame_callback</a>    (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglFrameCallback" title="CoglFrameCallback ()"><span class="type">CoglFrameCallback</span></a> callback</code></em>,
                                                         <em class="parameter"><code><span class="type">void</span> *user_data</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-The-Object-Interface.html#CoglUserDataDestroyCallback" title="CoglUserDataDestroyCallback"><span class="type">CoglUserDataDestroyCallback</span></a> destroy</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-remove-frame-callback" title="cogl_onscreen_remove_frame_callback ()">cogl_onscreen_remove_frame_callback</a> (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglFrameClosure" title="CoglFrameClosure"><span class="type">CoglFrameClosure</span></a> *closure</code></em>);

struct              <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreenDirtyInfo" title="struct CoglOnscreenDirtyInfo">CoglOnscreenDirtyInfo</a>;
<span class="returnvalue">void</span>                (<a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreenDirtyCallback" title="CoglOnscreenDirtyCallback ()">*CoglOnscreenDirtyCallback</a>)        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreenDirtyInfo" title="struct CoglOnscreenDirtyInfo"><span class="type">CoglOnscreenDirtyInfo</span></a> *info</code></em>,
                                                         <em class="parameter"><code><span class="type">void</span> *user_data</code></em>);
typedef             <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreenDirtyClosure" title="CoglOnscreenDirtyClosure">CoglOnscreenDirtyClosure</a>;
<a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreenDirtyClosure" title="CoglOnscreenDirtyClosure"><span class="returnvalue">CoglOnscreenDirtyClosure</span></a> * <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-add-dirty-callback" title="cogl_onscreen_add_dirty_callback ()">cogl_onscreen_add_dirty_callback</a>
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreenDirtyCallback" title="CoglOnscreenDirtyCallback ()"><span class="type">CoglOnscreenDirtyCallback</span></a> callback</code></em>,
                                                         <em class="parameter"><code><span class="type">void</span> *user_data</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-The-Object-Interface.html#CoglUserDataDestroyCallback" title="CoglUserDataDestroyCallback"><span class="type">CoglUserDataDestroyCallback</span></a> destroy</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-remove-dirty-callback" title="cogl_onscreen_remove_dirty_callback ()">cogl_onscreen_remove_dirty_callback</a> (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreenDirtyClosure" title="CoglOnscreenDirtyClosure"><span class="type">CoglOnscreenDirtyClosure</span></a> *closure</code></em>);

<span class="returnvalue">void</span>                (<a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreenResizeCallback" title="CoglOnscreenResizeCallback ()">*CoglOnscreenResizeCallback</a>)       (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>,
                                                         <em class="parameter"><code><span class="type">int</span> width</code></em>,
                                                         <em class="parameter"><code><span class="type">int</span> height</code></em>,
                                                         <em class="parameter"><code><span class="type">void</span> *user_data</code></em>);
typedef             <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreenResizeClosure" title="CoglOnscreenResizeClosure">CoglOnscreenResizeClosure</a>;
<a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreenResizeClosure" title="CoglOnscreenResizeClosure"><span class="returnvalue">CoglOnscreenResizeClosure</span></a> * <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-add-resize-callback" title="cogl_onscreen_add_resize_callback ()">cogl_onscreen_add_resize_callback</a>
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreenResizeCallback" title="CoglOnscreenResizeCallback ()"><span class="type">CoglOnscreenResizeCallback</span></a> callback</code></em>,
                                                         <em class="parameter"><code><span class="type">void</span> *user_data</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-The-Object-Interface.html#CoglUserDataDestroyCallback" title="CoglUserDataDestroyCallback"><span class="type">CoglUserDataDestroyCallback</span></a> destroy</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-remove-resize-callback" title="cogl_onscreen_remove_resize_callback ()">cogl_onscreen_remove_resize_callback</a>
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreenResizeClosure" title="CoglOnscreenResizeClosure"><span class="type">CoglOnscreenResizeClosure</span></a> *closure</code></em>);

<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-swap-buffers" title="cogl_onscreen_swap_buffers ()">cogl_onscreen_swap_buffers</a>          (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-swap-buffers-with-damage" title="cogl_onscreen_swap_buffers_with_damage ()">cogl_onscreen_swap_buffers_with_damage</a>
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>,
                                                         <em class="parameter"><code>const <span class="type">int</span> *rectangles</code></em>,
                                                         <em class="parameter"><code><span class="type">int</span> n_rectangles</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-swap-region" title="cogl_onscreen_swap_region ()">cogl_onscreen_swap_region</a>           (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>,
                                                         <em class="parameter"><code>const <span class="type">int</span> *rectangles</code></em>,
                                                         <em class="parameter"><code><span class="type">int</span> n_rectangles</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-set-swap-throttled" title="cogl_onscreen_set_swap_throttled ()">cogl_onscreen_set_swap_throttled</a>    (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="type">CoglBool</span></a> throttled</code></em>);
<span class="returnvalue">void</span>                (<a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglSwapBuffersNotify" title="CoglSwapBuffersNotify ()">*CoglSwapBuffersNotify</a>)            (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglFramebuffer---The-Framebuffer-Interface.html#CoglFramebuffer" title="CoglFramebuffer"><span class="type">CoglFramebuffer</span></a> *framebuffer</code></em>,
                                                         <em class="parameter"><code><span class="type">void</span> *user_data</code></em>);
unsigned <span class="returnvalue">int</span>        <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-add-swap-buffers-callback" title="cogl_onscreen_add_swap_buffers_callback ()">cogl_onscreen_add_swap_buffers_callback</a>
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglSwapBuffersNotify" title="CoglSwapBuffersNotify ()"><span class="type">CoglSwapBuffersNotify</span></a> callback</code></em>,
                                                         <em class="parameter"><code><span class="type">void</span> *user_data</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-remove-swap-buffers-callback" title="cogl_onscreen_remove_swap_buffers_callback ()">cogl_onscreen_remove_swap_buffers_callback</a>
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>,
                                                         <em class="parameter"><code>unsigned <span class="type">int</span> id</code></em>);
</pre>
</div>
<div class="refsect1">
<a name="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.description"></a><h2>Description</h2>
</div>
<div class="refsect1">
<a name="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.details"></a><h2>Details</h2>
<div class="refsect2">
<a name="CoglOnscreen"></a><h3>CoglOnscreen</h3>
<pre class="programlisting">typedef struct _CoglOnscreen CoglOnscreen;</pre>
</div>
<hr>
<div class="refsect2">
<a name="cogl-is-onscreen"></a><h3>cogl_is_onscreen ()</h3>
<pre class="programlisting"><a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="returnvalue">CoglBool</span></a>            cogl_is_onscreen                    (<em class="parameter"><code><span class="type">void</span> *object</code></em>);</pre>
<p>
Gets whether the given object references a <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a>.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>object</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-The-Object-Interface.html#CoglObject" title="CoglObject"><span class="type">CoglObject</span></a> pointer</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>
<a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#TRUE:CAPS"><code class="literal">TRUE</code></a> if the object references a <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a>
and <a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#FALSE:CAPS"><code class="literal">FALSE</code></a> otherwise.</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.10</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="COGL-ONSCREEN:CAPS"></a><h3>COGL_ONSCREEN()</h3>
<pre class="programlisting">#define COGL_ONSCREEN(X) ((CoglOnscreen *)(X))
</pre>
</div>
<hr>
<div class="refsect2">
<a name="cogl-onscreen-new"></a><h3>cogl_onscreen_new ()</h3>
<pre class="programlisting"><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="returnvalue">CoglOnscreen</span></a> *      cogl_onscreen_new                   (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-The-Top-Level-Context.html#CoglContext" title="CoglContext"><span class="type">CoglContext</span></a> *context</code></em>,
                                                         <em class="parameter"><code><span class="type">int</span> width</code></em>,
                                                         <em class="parameter"><code><span class="type">int</span> height</code></em>);</pre>
<p>
Instantiates an "unallocated" <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> framebuffer that may be
configured before later being allocated, either implicitly when
it is first used or explicitly via <a class="link" href="cogl-2.0-experimental-CoglFramebuffer---The-Framebuffer-Interface.html#cogl-framebuffer-allocate" title="cogl_framebuffer_allocate ()"><code class="function">cogl_framebuffer_allocate()</code></a>.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>context</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-The-Top-Level-Context.html#CoglContext" title="CoglContext"><span class="type">CoglContext</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>width</code></em> :</span></p></td>
<td>The desired framebuffer width</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>height</code></em> :</span></p></td>
<td>The desired framebuffer height</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>A newly instantiated <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> framebuffer. <span class="annotation">[<acronym title="Free data after the code is done."><span class="acronym">transfer full</span></acronym>]</span>
</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.8</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="CoglOnscreenX11MaskCallback"></a><h3>CoglOnscreenX11MaskCallback ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                (*CoglOnscreenX11MaskCallback)      (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>,
                                                         <em class="parameter"><code><span class="type">uint32_t</span> event_mask</code></em>,
                                                         <em class="parameter"><code><span class="type">void</span> *user_data</code></em>);</pre>
</div>
<hr>
<div class="refsect2">
<a name="cogl-x11-onscreen-set-foreign-window-xid"></a><h3>cogl_x11_onscreen_set_foreign_window_xid ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_x11_onscreen_set_foreign_window_xid
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>,
                                                         <em class="parameter"><code><span class="type">uint32_t</span> xid</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreenX11MaskCallback" title="CoglOnscreenX11MaskCallback ()"><span class="type">CoglOnscreenX11MaskCallback</span></a> update</code></em>,
                                                         <em class="parameter"><code><span class="type">void</span> *user_data</code></em>);</pre>
<p>
Ideally we would recommend that you let Cogl be responsible for
creating any X window required to back an onscreen framebuffer but
if you really need to target a window created manually this
function can be called before <em class="parameter"><code>onscreen</code></em> has been allocated to set a
foreign XID for your existing X window.
</p>
<p>
Since Cogl needs, for example, to track changes to the size of an X
window it requires that certain events be selected for via the core
X protocol. This requirement may also be changed asynchronously so
you must pass in an <em class="parameter"><code>update</code></em> callback to inform you of Cogl's
required event mask.
</p>
<p>
For example if you are using Xlib you could use this API roughly
as follows:
[{
static void
my_update_cogl_x11_event_mask (CoglOnscreen *onscreen,
                               uint32_t event_mask,
                               void *user_data)
{
  XSetWindowAttributes attrs;
  MyData *data = user_data;
  attrs.event_mask = event_mask | data-&gt;my_event_mask;
  XChangeWindowAttributes (data-&gt;xdpy,
                           data-&gt;xwin,
                           CWEventMask,
                           &amp;attrs);
}
</p>
<p>
{
  *snip*
  cogl_x11_onscreen_set_foreign_window_xid (onscreen,
                                            data-&gt;xwin,
                                            my_update_cogl_x11_event_mask,
                                            data);
  *snip*
}
}]
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>onscreen</code></em> :</span></p></td>
<td>The unallocated framebuffer to associated with an X
window.</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>xid</code></em> :</span></p></td>
<td>The XID of an existing X window</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>update</code></em> :</span></p></td>
<td>A callback that notifies of updates to what Cogl requires
to be in the core X protocol event mask.</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>user_data</code></em> :</span></p></td>
<td>user data passed to <em class="parameter"><code>update</code></em>
</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 2.0</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-x11-onscreen-get-window-xid"></a><h3>cogl_x11_onscreen_get_window_xid ()</h3>
<pre class="programlisting"><span class="returnvalue">uint32_t</span>            cogl_x11_onscreen_get_window_xid    (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>);</pre>
<p>
Assuming you know the given <em class="parameter"><code>onscreen</code></em> framebuffer is based on an x11 window
this queries the XID of that window. If
<a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-x11-onscreen-set-foreign-window-xid" title="cogl_x11_onscreen_set_foreign_window_xid ()"><code class="function">cogl_x11_onscreen_set_foreign_window_xid()</code></a> was previously called then it
will return that same XID otherwise it will be the XID of a window Cogl
created internally. If the window has not been allocated yet and a foreign
xid has not been set then it's undefined what value will be returned.
</p>
<p>
It's undefined what this function does if called when not using an x11 based
renderer.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody><tr>
<td><p><span class="term"><em class="parameter"><code>onscreen</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> framebuffer</td>
</tr></tbody>
</table></div>
<p class="since">Since 1.10</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-x11-onscreen-get-visual-xid"></a><h3>cogl_x11_onscreen_get_visual_xid ()</h3>
<pre class="programlisting"><span class="returnvalue">uint32_t</span>            cogl_x11_onscreen_get_visual_xid    (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>);</pre>
</div>
<hr>
<div class="refsect2">
<a name="cogl-win32-onscreen-set-foreign-window"></a><h3>cogl_win32_onscreen_set_foreign_window ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_win32_onscreen_set_foreign_window
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>,
                                                         <em class="parameter"><code><span class="type">HWND</span> hwnd</code></em>);</pre>
<p>
Ideally we would recommend that you let Cogl be responsible for
creating any window required to back an onscreen framebuffer but
if you really need to target a window created manually this
function can be called before <em class="parameter"><code>onscreen</code></em> has been allocated to set a
foreign XID for your existing X window.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>onscreen</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> framebuffer</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>hwnd</code></em> :</span></p></td>
<td>A win32 window handle</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.10</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-win32-onscreen-get-window"></a><h3>cogl_win32_onscreen_get_window ()</h3>
<pre class="programlisting"><span class="returnvalue">HWND</span>                cogl_win32_onscreen_get_window      (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>);</pre>
<p>
Queries the internally created window HWND backing the given <em class="parameter"><code>onscreen</code></em>
framebuffer.  If <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-win32-onscreen-set-foreign-window" title="cogl_win32_onscreen_set_foreign_window ()"><code class="function">cogl_win32_onscreen_set_foreign_window()</code></a> has been used then
it will return the same handle set with that API.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody><tr>
<td><p><span class="term"><em class="parameter"><code>onscreen</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> framebuffer</td>
</tr></tbody>
</table></div>
<p class="since">Since 1.10</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-onscreen-show"></a><h3>cogl_onscreen_show ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_onscreen_show                  (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>);</pre>
<p>
This requests to make <em class="parameter"><code>onscreen</code></em> visible to the user.
</p>
<p>
Actually the precise semantics of this function depend on the
window system currently in use, and if you don't have a
multi-windowining system this function may in-fact do nothing.
</p>
<p>
This function will implicitly allocate the given <em class="parameter"><code>onscreen</code></em>
framebuffer before showing it if it hasn't already been allocated.
</p>
<p>
When using the Wayland winsys calling this will set the surface to
a toplevel type which will make it appear. If the application wants
to set a different type for the surface, it can avoid calling
<a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-show" title="cogl_onscreen_show ()"><code class="function">cogl_onscreen_show()</code></a> and set its own type directly with the Wayland
client API via <code class="function">cogl_wayland_onscreen_get_surface()</code>.
</p>
<p>
</p>
<div class="note" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Note</h3>Since Cogl doesn't explicitly track the visibility status of
onscreen framebuffers it wont try to avoid redundant window system
requests e.g. to show an already visible window. This also means
that it's acceptable to alternatively use native APIs to show and
hide windows without confusing Cogl.</div>
<p>
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody><tr>
<td><p><span class="term"><em class="parameter"><code>onscreen</code></em> :</span></p></td>
<td>The onscreen framebuffer to make visible</td>
</tr></tbody>
</table></div>
<p class="since">Since 2.0</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-onscreen-hide"></a><h3>cogl_onscreen_hide ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_onscreen_hide                  (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>);</pre>
<p>
This requests to make <em class="parameter"><code>onscreen</code></em> invisible to the user.
</p>
<p>
Actually the precise semantics of this function depend on the
window system currently in use, and if you don't have a
multi-windowining system this function may in-fact do nothing.
</p>
<p>
This function does not implicitly allocate the given <em class="parameter"><code>onscreen</code></em>
framebuffer before hiding it.
</p>
<p>
</p>
<div class="note" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Note</h3>Since Cogl doesn't explicitly track the visibility status of
onscreen framebuffers it wont try to avoid redundant window system
requests e.g. to show an already visible window. This also means
that it's acceptable to alternatively use native APIs to show and
hide windows without confusing Cogl.</div>
<p>
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody><tr>
<td><p><span class="term"><em class="parameter"><code>onscreen</code></em> :</span></p></td>
<td>The onscreen framebuffer to make invisible</td>
</tr></tbody>
</table></div>
<p class="since">Since 2.0</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="CoglFrameCallback"></a><h3>CoglFrameCallback ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                (*CoglFrameCallback)                (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>,
                                                         <em class="parameter"><code><span class="type">CoglFrameEvent</span> event</code></em>,
                                                         <em class="parameter"><code><span class="type">CoglFrameInfo</span> *info</code></em>,
                                                         <em class="parameter"><code><span class="type">void</span> *user_data</code></em>);</pre>
<p>
Is a callback that can be registered via
<a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-add-frame-callback" title="cogl_onscreen_add_frame_callback ()"><code class="function">cogl_onscreen_add_frame_callback()</code></a> to be called when a frame
progresses in some notable way.
</p>
<p>
Please see the documentation for <span class="type">CoglFrameEvent</span> and
<a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-add-frame-callback" title="cogl_onscreen_add_frame_callback ()"><code class="function">cogl_onscreen_add_frame_callback()</code></a> for more details about what
events can be notified.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>onscreen</code></em> :</span></p></td>
<td>The onscreen that the frame is associated with</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>event</code></em> :</span></p></td>
<td>A <span class="type">CoglFrameEvent</span> notifying how the frame has progressed</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>info</code></em> :</span></p></td>
<td>The meta information, such as timing information, about
the frame that has progressed.</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>user_data</code></em> :</span></p></td>
<td>The user pointer passed to
<a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-add-frame-callback" title="cogl_onscreen_add_frame_callback ()"><code class="function">cogl_onscreen_add_frame_callback()</code></a>
</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.14</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="CoglFrameClosure"></a><h3>CoglFrameClosure</h3>
<pre class="programlisting">typedef struct _CoglClosure CoglFrameClosure;
</pre>
<p>
An opaque type that tracks a <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglFrameCallback" title="CoglFrameCallback ()"><span class="type">CoglFrameCallback</span></a> and associated user
data. A <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglFrameClosure" title="CoglFrameClosure"><span class="type">CoglFrameClosure</span></a> pointer will be returned from
<a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-add-frame-callback" title="cogl_onscreen_add_frame_callback ()"><code class="function">cogl_onscreen_add_frame_callback()</code></a> and it allows you to remove a
callback later using <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-remove-frame-callback" title="cogl_onscreen_remove_frame_callback ()"><code class="function">cogl_onscreen_remove_frame_callback()</code></a>.
</p>
<p class="since">Since 1.14</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-onscreen-add-frame-callback"></a><h3>cogl_onscreen_add_frame_callback ()</h3>
<pre class="programlisting"><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglFrameClosure" title="CoglFrameClosure"><span class="returnvalue">CoglFrameClosure</span></a> *  cogl_onscreen_add_frame_callback    (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglFrameCallback" title="CoglFrameCallback ()"><span class="type">CoglFrameCallback</span></a> callback</code></em>,
                                                         <em class="parameter"><code><span class="type">void</span> *user_data</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-The-Object-Interface.html#CoglUserDataDestroyCallback" title="CoglUserDataDestroyCallback"><span class="type">CoglUserDataDestroyCallback</span></a> destroy</code></em>);</pre>
<p>
Installs a <em class="parameter"><code>callback</code></em> function that will be called for significant
events relating to the given <em class="parameter"><code>onscreen</code></em> framebuffer.
</p>
<p>
The <em class="parameter"><code>callback</code></em> will be used to notify when the system compositor is
ready for this application to render a new frame. In this case
<code class="literal">COGL_FRAME_EVENT_SYNC</code> will be passed as the event argument to the
given <em class="parameter"><code>callback</code></em> in addition to the <span class="type">CoglFrameInfo</span> corresponding to
the frame beeing acknowledged by the compositor.
</p>
<p>
The <em class="parameter"><code>callback</code></em> will also be called to notify when the frame has
ended. In this case <code class="literal">COGL_FRAME_EVENT_COMPLETE</code> will be passed as
the event argument to the given <em class="parameter"><code>callback</code></em> in addition to the
<span class="type">CoglFrameInfo</span> corresponding to the newly presented frame.  The
meaning of "ended" here simply means that no more timing
information will be collected within the corresponding
<span class="type">CoglFrameInfo</span> and so this is a good opportunity to analyse the
given info. It does not necessarily mean that the GPU has finished
rendering the corresponding frame.
</p>
<p>
We highly recommend throttling your application according to
<code class="literal">COGL_FRAME_EVENT_SYNC</code> events so that your application can avoid
wasting resources, drawing more frames than your system compositor
can display.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>onscreen</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> framebuffer</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>callback</code></em> :</span></p></td>
<td>A callback function to call for frame events. <span class="annotation">[<acronym title="The callback is valid until the GDestroyNotify argument is called."><span class="acronym">scope notified</span></acronym>]</span>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>user_data</code></em> :</span></p></td>
<td>A private pointer to be passed to <em class="parameter"><code>callback</code></em>. <span class="annotation">[<acronym title="This parameter is a 'user_data', for callbacks; many bindings can pass NULL here."><span class="acronym">closure</span></acronym>]</span>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>destroy</code></em> :</span></p></td>
<td>An optional callback to destroy <em class="parameter"><code>user_data</code></em>
when the <em class="parameter"><code>callback</code></em> is removed or <em class="parameter"><code>onscreen</code></em> is freed. <span class="annotation">[<acronym title="NULL is ok, both for passing and for returning."><span class="acronym">allow-none</span></acronym>]</span>
</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>a <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglFrameClosure" title="CoglFrameClosure"><span class="type">CoglFrameClosure</span></a> pointer that can be used to
remove the callback and associated <em class="parameter"><code>user_data</code></em> later.</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.14</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-onscreen-remove-frame-callback"></a><h3>cogl_onscreen_remove_frame_callback ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_onscreen_remove_frame_callback (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglFrameClosure" title="CoglFrameClosure"><span class="type">CoglFrameClosure</span></a> *closure</code></em>);</pre>
<p>
Removes a callback and associated user data that were previously
registered using <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-add-frame-callback" title="cogl_onscreen_add_frame_callback ()"><code class="function">cogl_onscreen_add_frame_callback()</code></a>.
</p>
<p>
If a destroy callback was passed to
<a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-add-frame-callback" title="cogl_onscreen_add_frame_callback ()"><code class="function">cogl_onscreen_add_frame_callback()</code></a> to destroy the user data then
this will get called.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>onscreen</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>closure</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglFrameClosure" title="CoglFrameClosure"><span class="type">CoglFrameClosure</span></a> returned from
<a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-add-frame-callback" title="cogl_onscreen_add_frame_callback ()"><code class="function">cogl_onscreen_add_frame_callback()</code></a>
</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.14</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="CoglOnscreenDirtyInfo"></a><h3>struct CoglOnscreenDirtyInfo</h3>
<pre class="programlisting">struct CoglOnscreenDirtyInfo {
  int x, y;
  int width, height;
};
</pre>
<p>
A structure passed to callbacks registered using
<a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-add-dirty-callback" title="cogl_onscreen_add_dirty_callback ()"><code class="function">cogl_onscreen_add_dirty_callback()</code></a>. The members describe a
rectangle within the onscreen buffer that should be redrawn.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><span class="type">int</span> <em class="structfield"><code><a name="CoglOnscreenDirtyInfo.x"></a>x</code></em>;</span></p></td>
<td>Left edge of the dirty rectangle</td>
</tr>
<tr>
<td><p><span class="term"><span class="type">int</span> <em class="structfield"><code><a name="CoglOnscreenDirtyInfo.y"></a>y</code></em>;</span></p></td>
<td>Top edge of the dirty rectangle, measured from the top of the window</td>
</tr>
<tr>
<td><p><span class="term"><span class="type">int</span> <em class="structfield"><code><a name="CoglOnscreenDirtyInfo.width"></a>width</code></em>;</span></p></td>
<td>Width of the dirty rectangle</td>
</tr>
<tr>
<td><p><span class="term"><span class="type">int</span> <em class="structfield"><code><a name="CoglOnscreenDirtyInfo.height"></a>height</code></em>;</span></p></td>
<td>Height of the dirty rectangle</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.16</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="CoglOnscreenDirtyCallback"></a><h3>CoglOnscreenDirtyCallback ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                (*CoglOnscreenDirtyCallback)        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreenDirtyInfo" title="struct CoglOnscreenDirtyInfo"><span class="type">CoglOnscreenDirtyInfo</span></a> *info</code></em>,
                                                         <em class="parameter"><code><span class="type">void</span> *user_data</code></em>);</pre>
<p>
Is a callback that can be registered via
<a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-add-dirty-callback" title="cogl_onscreen_add_dirty_callback ()"><code class="function">cogl_onscreen_add_dirty_callback()</code></a> to be called when the windowing
system determines that a region of the onscreen window has been
lost and the application should redraw it.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>onscreen</code></em> :</span></p></td>
<td>The onscreen that the frame is associated with</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>info</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreenDirtyInfo" title="struct CoglOnscreenDirtyInfo"><span class="type">CoglOnscreenDirtyInfo</span></a> struct containing the details of the
dirty area</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>user_data</code></em> :</span></p></td>
<td>The user pointer passed to
<a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-add-frame-callback" title="cogl_onscreen_add_frame_callback ()"><code class="function">cogl_onscreen_add_frame_callback()</code></a>
</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.16</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="CoglOnscreenDirtyClosure"></a><h3>CoglOnscreenDirtyClosure</h3>
<pre class="programlisting">typedef struct _CoglClosure CoglOnscreenDirtyClosure;
</pre>
<p>
An opaque type that tracks a <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreenDirtyCallback" title="CoglOnscreenDirtyCallback ()"><span class="type">CoglOnscreenDirtyCallback</span></a> and associated
user data. A <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreenDirtyClosure" title="CoglOnscreenDirtyClosure"><span class="type">CoglOnscreenDirtyClosure</span></a> pointer will be returned from
<a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-add-dirty-callback" title="cogl_onscreen_add_dirty_callback ()"><code class="function">cogl_onscreen_add_dirty_callback()</code></a> and it allows you to remove a
callback later using <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-remove-dirty-callback" title="cogl_onscreen_remove_dirty_callback ()"><code class="function">cogl_onscreen_remove_dirty_callback()</code></a>.
</p>
<p class="since">Since 1.16</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-onscreen-add-dirty-callback"></a><h3>cogl_onscreen_add_dirty_callback ()</h3>
<pre class="programlisting"><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreenDirtyClosure" title="CoglOnscreenDirtyClosure"><span class="returnvalue">CoglOnscreenDirtyClosure</span></a> * cogl_onscreen_add_dirty_callback
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreenDirtyCallback" title="CoglOnscreenDirtyCallback ()"><span class="type">CoglOnscreenDirtyCallback</span></a> callback</code></em>,
                                                         <em class="parameter"><code><span class="type">void</span> *user_data</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-The-Object-Interface.html#CoglUserDataDestroyCallback" title="CoglUserDataDestroyCallback"><span class="type">CoglUserDataDestroyCallback</span></a> destroy</code></em>);</pre>
<p>
Installs a <em class="parameter"><code>callback</code></em> function that will be called whenever the
window system has lost the contents of a region of the onscreen
buffer and the application should redraw it to repair the buffer.
For example this may happen in a window system without a compositor
if a window that was previously covering up the onscreen window has
been moved causing a region of the onscreen to be exposed.
</p>
<p>
The <em class="parameter"><code>callback</code></em> will be passed a <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreenDirtyInfo" title="struct CoglOnscreenDirtyInfo"><span class="type">CoglOnscreenDirtyInfo</span></a> struct which
decribes a rectangle containing the newly dirtied region. Note that
this may be called multiple times to describe a non-rectangular
region composed of multiple smaller rectangles.
</p>
<p>
The dirty events are separate from <code class="literal">COGL_FRAME_EVENT_SYNC</code> events so
the application should also listen for this event before rendering
the dirty region to ensure that the framebuffer is actually ready
for rendering.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>onscreen</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> framebuffer</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>callback</code></em> :</span></p></td>
<td>A callback function to call for dirty events. <span class="annotation">[<acronym title="The callback is valid until the GDestroyNotify argument is called."><span class="acronym">scope notified</span></acronym>]</span>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>user_data</code></em> :</span></p></td>
<td>A private pointer to be passed to <em class="parameter"><code>callback</code></em>. <span class="annotation">[<acronym title="This parameter is a 'user_data', for callbacks; many bindings can pass NULL here."><span class="acronym">closure</span></acronym>]</span>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>destroy</code></em> :</span></p></td>
<td>An optional callback to destroy <em class="parameter"><code>user_data</code></em> when the
<em class="parameter"><code>callback</code></em> is removed or <em class="parameter"><code>onscreen</code></em> is freed. <span class="annotation">[<acronym title="NULL is ok, both for passing and for returning."><span class="acronym">allow-none</span></acronym>]</span>
</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>a <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreenDirtyClosure" title="CoglOnscreenDirtyClosure"><span class="type">CoglOnscreenDirtyClosure</span></a> pointer that can be used to
remove the callback and associated <em class="parameter"><code>user_data</code></em> later.</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.16</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-onscreen-remove-dirty-callback"></a><h3>cogl_onscreen_remove_dirty_callback ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_onscreen_remove_dirty_callback (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreenDirtyClosure" title="CoglOnscreenDirtyClosure"><span class="type">CoglOnscreenDirtyClosure</span></a> *closure</code></em>);</pre>
<p>
Removes a callback and associated user data that were previously
registered using <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-add-dirty-callback" title="cogl_onscreen_add_dirty_callback ()"><code class="function">cogl_onscreen_add_dirty_callback()</code></a>.
</p>
<p>
If a destroy callback was passed to
<a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-add-dirty-callback" title="cogl_onscreen_add_dirty_callback ()"><code class="function">cogl_onscreen_add_dirty_callback()</code></a> to destroy the user data then
this will also get called.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>onscreen</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>closure</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreenDirtyClosure" title="CoglOnscreenDirtyClosure"><span class="type">CoglOnscreenDirtyClosure</span></a> returned from
<a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-add-dirty-callback" title="cogl_onscreen_add_dirty_callback ()"><code class="function">cogl_onscreen_add_dirty_callback()</code></a>
</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.16</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="CoglOnscreenResizeCallback"></a><h3>CoglOnscreenResizeCallback ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                (*CoglOnscreenResizeCallback)       (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>,
                                                         <em class="parameter"><code><span class="type">int</span> width</code></em>,
                                                         <em class="parameter"><code><span class="type">int</span> height</code></em>,
                                                         <em class="parameter"><code><span class="type">void</span> *user_data</code></em>);</pre>
<p>
Is a callback type used with the
<a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-add-resize-callback" title="cogl_onscreen_add_resize_callback ()"><code class="function">cogl_onscreen_add_resize_callback()</code></a> allowing applications to be
notified whenever an <em class="parameter"><code>onscreen</code></em> framebuffer is resized.
</p>
<p>
</p>
<div class="note" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Note</h3>Cogl automatically updates the viewport of an <em class="parameter"><code>onscreen</code></em>
framebuffer that is resized so this callback is also an indication
that the viewport has been modified too</div>
<p>
</p>
<p>
</p>
<div class="note" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Note</h3>A resize callback will only ever be called while dispatching
Cogl events from the system mainloop; so for example during
<a class="link" href="cogl-2.0-experimental-Main-loop-integration.html#cogl-poll-renderer-dispatch" title="cogl_poll_renderer_dispatch ()"><code class="function">cogl_poll_renderer_dispatch()</code></a>. This is so that callbacks shouldn't
occur while an application might have arbitrary locks held for
example.</div>
<p>
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>onscreen</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> framebuffer that was resized</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>width</code></em> :</span></p></td>
<td>The new width of <em class="parameter"><code>onscreen</code></em>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>height</code></em> :</span></p></td>
<td>The new height of <em class="parameter"><code>onscreen</code></em>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>user_data</code></em> :</span></p></td>
<td>The private passed to
<a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-add-resize-callback" title="cogl_onscreen_add_resize_callback ()"><code class="function">cogl_onscreen_add_resize_callback()</code></a>
</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 2.0</p>
</div>
<hr>
<div class="refsect2">
<a name="CoglOnscreenResizeClosure"></a><h3>CoglOnscreenResizeClosure</h3>
<pre class="programlisting">typedef struct _CoglClosure CoglOnscreenResizeClosure;
</pre>
<p>
An opaque type that tracks a <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreenResizeCallback" title="CoglOnscreenResizeCallback ()"><span class="type">CoglOnscreenResizeCallback</span></a> and
associated user data. A <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreenResizeClosure" title="CoglOnscreenResizeClosure"><span class="type">CoglOnscreenResizeClosure</span></a> pointer will be
returned from <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-add-resize-callback" title="cogl_onscreen_add_resize_callback ()"><code class="function">cogl_onscreen_add_resize_callback()</code></a> and it allows you
to remove a callback later using
<a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-remove-resize-callback" title="cogl_onscreen_remove_resize_callback ()"><code class="function">cogl_onscreen_remove_resize_callback()</code></a>.
</p>
<p class="since">Since 2.0</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-onscreen-add-resize-callback"></a><h3>cogl_onscreen_add_resize_callback ()</h3>
<pre class="programlisting"><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreenResizeClosure" title="CoglOnscreenResizeClosure"><span class="returnvalue">CoglOnscreenResizeClosure</span></a> * cogl_onscreen_add_resize_callback
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreenResizeCallback" title="CoglOnscreenResizeCallback ()"><span class="type">CoglOnscreenResizeCallback</span></a> callback</code></em>,
                                                         <em class="parameter"><code><span class="type">void</span> *user_data</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-The-Object-Interface.html#CoglUserDataDestroyCallback" title="CoglUserDataDestroyCallback"><span class="type">CoglUserDataDestroyCallback</span></a> destroy</code></em>);</pre>
<p>
Registers a <em class="parameter"><code>callback</code></em> with <em class="parameter"><code>onscreen</code></em> that will be called whenever
the <em class="parameter"><code>onscreen</code></em> framebuffer changes size.
</p>
<p>
The <em class="parameter"><code>callback</code></em> can be removed using
<a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-remove-resize-callback" title="cogl_onscreen_remove_resize_callback ()"><code class="function">cogl_onscreen_remove_resize_callback()</code></a> passing the returned closure
pointer.
</p>
<p>
</p>
<div class="note" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Note</h3>Since Cogl automatically updates the viewport of an <em class="parameter"><code>onscreen</code></em>
framebuffer that is resized, a resize callback can also be used to
track when the viewport has been changed automatically by Cogl in
case your application needs more specialized control over the
viewport.</div>
<p>
</p>
<p>
</p>
<div class="note" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Note</h3>A resize callback will only ever be called while dispatching
Cogl events from the system mainloop; so for example during
<a class="link" href="cogl-2.0-experimental-Main-loop-integration.html#cogl-poll-renderer-dispatch" title="cogl_poll_renderer_dispatch ()"><code class="function">cogl_poll_renderer_dispatch()</code></a>. This is so that callbacks shouldn't
occur while an application might have arbitrary locks held for
example.</div>
<p>
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>onscreen</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> framebuffer</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>callback</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreenResizeCallback" title="CoglOnscreenResizeCallback ()"><span class="type">CoglOnscreenResizeCallback</span></a> to call when
the <em class="parameter"><code>onscreen</code></em> changes size. <span class="annotation">[<acronym title="The callback is valid until the GDestroyNotify argument is called."><span class="acronym">scope notified</span></acronym>]</span>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>user_data</code></em> :</span></p></td>
<td>Private data to be passed to <em class="parameter"><code>callback</code></em>. <span class="annotation">[<acronym title="This parameter is a 'user_data', for callbacks; many bindings can pass NULL here."><span class="acronym">closure</span></acronym>]</span>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>destroy</code></em> :</span></p></td>
<td>An optional callback to destroy <em class="parameter"><code>user_data</code></em>
when the <em class="parameter"><code>callback</code></em> is removed or <em class="parameter"><code>onscreen</code></em> is freed. <span class="annotation">[<acronym title="NULL is ok, both for passing and for returning."><span class="acronym">allow-none</span></acronym>]</span>
</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>a <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreenResizeClosure" title="CoglOnscreenResizeClosure"><span class="type">CoglOnscreenResizeClosure</span></a> pointer that can be used to
remove the callback and associated <em class="parameter"><code>user_data</code></em> later.</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 2.0</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-onscreen-remove-resize-callback"></a><h3>cogl_onscreen_remove_resize_callback ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_onscreen_remove_resize_callback
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreenResizeClosure" title="CoglOnscreenResizeClosure"><span class="type">CoglOnscreenResizeClosure</span></a> *closure</code></em>);</pre>
<p>
Removes a resize <em class="parameter"><code>callback</code></em> and <em class="parameter"><code>user_data</code></em> pair that were previously
associated with <em class="parameter"><code>onscreen</code></em> via <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-add-resize-callback" title="cogl_onscreen_add_resize_callback ()"><code class="function">cogl_onscreen_add_resize_callback()</code></a>.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>onscreen</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> framebuffer</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>closure</code></em> :</span></p></td>
<td>An identifier returned from <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-add-resize-callback" title="cogl_onscreen_add_resize_callback ()"><code class="function">cogl_onscreen_add_resize_callback()</code></a>
</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 2.0</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-onscreen-swap-buffers"></a><h3>cogl_onscreen_swap_buffers ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_onscreen_swap_buffers          (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>);</pre>
<p>
Swaps the current back buffer being rendered too, to the front for display.
</p>
<p>
This function also implicitly discards the contents of the color, depth and
stencil buffers as if <a class="link" href="cogl-2.0-experimental-CoglFramebuffer---The-Framebuffer-Interface.html#cogl-framebuffer-discard-buffers" title="cogl_framebuffer_discard_buffers ()"><code class="function">cogl_framebuffer_discard_buffers()</code></a> were used. The
significance of the discard is that you should not expect to be able to
start a new frame that incrementally builds on the contents of the previous
frame.
</p>
<p>
</p>
<div class="note" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Note</h3>It is highly recommended that applications use
<a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-swap-buffers-with-damage" title="cogl_onscreen_swap_buffers_with_damage ()"><code class="function">cogl_onscreen_swap_buffers_with_damage()</code></a> instead whenever possible
and also use the <code class="function">cogl_onscreen_get_buffer_age()</code> api so they can
perform incremental updates to older buffers instead of having to
render a full buffer for every frame.</div>
<p>
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody><tr>
<td><p><span class="term"><em class="parameter"><code>onscreen</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> framebuffer</td>
</tr></tbody>
</table></div>
<p class="since">Since 1.10</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-onscreen-swap-buffers-with-damage"></a><h3>cogl_onscreen_swap_buffers_with_damage ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_onscreen_swap_buffers_with_damage
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>,
                                                         <em class="parameter"><code>const <span class="type">int</span> *rectangles</code></em>,
                                                         <em class="parameter"><code><span class="type">int</span> n_rectangles</code></em>);</pre>
<p>
Swaps the current back buffer being rendered too, to the front for
display and provides information to any system compositor about
what regions of the buffer have changed (damage) with respect to
the last swapped buffer.
</p>
<p>
This function has the same semantics as
<code class="function">cogl_framebuffer_swap_buffers()</code> except that it additionally allows
applications to pass a list of damaged rectangles which may be
passed on to a compositor so that it can minimize how much of the
screen is redrawn in response to this applications newly swapped
front buffer.
</p>
<p>
For example if your application is only animating a small object in
the corner of the screen and everything else is remaining static
then it can help the compositor to know that only the bottom right
corner of your newly swapped buffer has really changed with respect
to your previously swapped front buffer.
</p>
<p>
If <em class="parameter"><code>n_rectangles</code></em> is 0 then the whole buffer will implicitly be
reported as damaged as if <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-swap-buffers" title="cogl_onscreen_swap_buffers ()"><code class="function">cogl_onscreen_swap_buffers()</code></a> had been
called.
</p>
<p>
This function also implicitly discards the contents of the color,
depth and stencil buffers as if <a class="link" href="cogl-2.0-experimental-CoglFramebuffer---The-Framebuffer-Interface.html#cogl-framebuffer-discard-buffers" title="cogl_framebuffer_discard_buffers ()"><code class="function">cogl_framebuffer_discard_buffers()</code></a>
were used. The significance of the discard is that you should not
expect to be able to start a new frame that incrementally builds on
the contents of the previous frame. If you want to perform
incremental updates to older back buffers then please refer to the
<code class="function">cogl_onscreen_get_buffer_age()</code> api.
</p>
<p>
Whenever possible it is recommended that applications use this
function instead of <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-swap-buffers" title="cogl_onscreen_swap_buffers ()"><code class="function">cogl_onscreen_swap_buffers()</code></a> to improve
performance when running under a compositor.
</p>
<p>
</p>
<div class="note" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Note</h3>It is highly recommended to use this API in conjunction with
the <code class="function">cogl_onscreen_get_buffer_age()</code> api so that your application can
perform incremental rendering based on old back buffers.</div>
<p>
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>onscreen</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> framebuffer</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>rectangles</code></em> :</span></p></td>
<td>An array of integer 4-tuples representing damaged
rectangles as (x, y, width, height) tuples.</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>n_rectangles</code></em> :</span></p></td>
<td>The number of 4-tuples to be read from <em class="parameter"><code>rectangles</code></em>
</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.16</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-onscreen-swap-region"></a><h3>cogl_onscreen_swap_region ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_onscreen_swap_region           (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>,
                                                         <em class="parameter"><code>const <span class="type">int</span> *rectangles</code></em>,
                                                         <em class="parameter"><code><span class="type">int</span> n_rectangles</code></em>);</pre>
<p>
Swaps a region of the back buffer being rendered too, to the front for
display.  <em class="parameter"><code>rectangles</code></em> represents the region as array of <em class="parameter"><code>n_rectangles</code></em> each
defined by 4 sequential (x, y, width, height) integers.
</p>
<p>
This function also implicitly discards the contents of the color, depth and
stencil buffers as if <a class="link" href="cogl-2.0-experimental-CoglFramebuffer---The-Framebuffer-Interface.html#cogl-framebuffer-discard-buffers" title="cogl_framebuffer_discard_buffers ()"><code class="function">cogl_framebuffer_discard_buffers()</code></a> were used. The
significance of the discard is that you should not expect to be able to
start a new frame that incrementally builds on the contents of the previous
frame.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>onscreen</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> framebuffer</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>rectangles</code></em> :</span></p></td>
<td>An array of integer 4-tuples representing rectangles as
(x, y, width, height) tuples.</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>n_rectangles</code></em> :</span></p></td>
<td>The number of 4-tuples to be read from <em class="parameter"><code>rectangles</code></em>
</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.10</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-onscreen-set-swap-throttled"></a><h3>cogl_onscreen_set_swap_throttled ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_onscreen_set_swap_throttled    (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="type">CoglBool</span></a> throttled</code></em>);</pre>
<p>
Requests that the given <em class="parameter"><code>onscreen</code></em> framebuffer should have swap buffer
requests (made using <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-swap-buffers" title="cogl_onscreen_swap_buffers ()"><code class="function">cogl_onscreen_swap_buffers()</code></a>) throttled either by a
displays vblank period or perhaps some other mechanism in a composited
environment.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>onscreen</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> framebuffer</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>throttled</code></em> :</span></p></td>
<td>Whether swap throttling is wanted or not.</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.8</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="CoglSwapBuffersNotify"></a><h3>CoglSwapBuffersNotify ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                (*CoglSwapBuffersNotify)            (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglFramebuffer---The-Framebuffer-Interface.html#CoglFramebuffer" title="CoglFramebuffer"><span class="type">CoglFramebuffer</span></a> *framebuffer</code></em>,
                                                         <em class="parameter"><code><span class="type">void</span> *user_data</code></em>);</pre>
</div>
<hr>
<div class="refsect2">
<a name="cogl-onscreen-add-swap-buffers-callback"></a><h3>cogl_onscreen_add_swap_buffers_callback ()</h3>
<pre class="programlisting">unsigned <span class="returnvalue">int</span>        cogl_onscreen_add_swap_buffers_callback
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglSwapBuffersNotify" title="CoglSwapBuffersNotify ()"><span class="type">CoglSwapBuffersNotify</span></a> callback</code></em>,
                                                         <em class="parameter"><code><span class="type">void</span> *user_data</code></em>);</pre>
<div class="warning" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Warning</h3>
<p><code class="literal">cogl_onscreen_add_swap_buffers_callback</code> has been deprecated since version 1.14 and should not be used in newly-written code. Use <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-add-frame-callback" title="cogl_onscreen_add_frame_callback ()"><code class="function">cogl_onscreen_add_frame_callback()</code></a> instead</p>
</div>
<p>
Installs a <em class="parameter"><code>callback</code></em> function that should be called whenever a swap buffers
request (made using <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-swap-buffers" title="cogl_onscreen_swap_buffers ()"><code class="function">cogl_onscreen_swap_buffers()</code></a>) for the given
<em class="parameter"><code>onscreen</code></em> completes.
</p>
<p>
</p>
<div class="note" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Note</h3>Applications should check for the <a class="link" href="cogl-2.0-experimental-The-Top-Level-Context.html#COGL-FEATURE-ID-SWAP-BUFFERS-EVENT:CAPS"><code class="literal">COGL_FEATURE_ID_SWAP_BUFFERS_EVENT</code></a>
feature before using this API. It's currently undefined when and if
registered callbacks will be called if this feature is not supported.</div>
<p>
</p>
<p>
We recommend using this mechanism when available to manually throttle your
applications (in conjunction with  <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-set-swap-throttled" title="cogl_onscreen_set_swap_throttled ()"><code class="function">cogl_onscreen_set_swap_throttled()</code></a>) so
your application will be able to avoid long blocks in the driver caused by
throttling when you request to swap buffers too quickly.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>onscreen</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> framebuffer</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>callback</code></em> :</span></p></td>
<td>A callback function to call when a swap
has completed. <span class="annotation">[<acronym title="The callback is valid until the GDestroyNotify argument is called."><span class="acronym">scope notified</span></acronym>]</span>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>user_data</code></em> :</span></p></td>
<td>A private pointer to be passed to <em class="parameter"><code>callback</code></em>. <span class="annotation">[<acronym title="This parameter is a 'user_data', for callbacks; many bindings can pass NULL here."><span class="acronym">closure</span></acronym>]</span>
</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>a unique identifier that can be used to remove to remove
the callback later.</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.10</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-onscreen-remove-swap-buffers-callback"></a><h3>cogl_onscreen_remove_swap_buffers_callback ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_onscreen_remove_swap_buffers_callback
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> *onscreen</code></em>,
                                                         <em class="parameter"><code>unsigned <span class="type">int</span> id</code></em>);</pre>
<div class="warning" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Warning</h3>
<p><code class="literal">cogl_onscreen_remove_swap_buffers_callback</code> has been deprecated since version 1.14 and should not be used in newly-written code. Use <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-remove-frame-callback" title="cogl_onscreen_remove_frame_callback ()"><code class="function">cogl_onscreen_remove_frame_callback()</code></a> instead</p>
</div>
<p>
Removes a callback that was previously registered
using <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-add-swap-buffers-callback" title="cogl_onscreen_add_swap_buffers_callback ()"><code class="function">cogl_onscreen_add_swap_buffers_callback()</code></a>.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>onscreen</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#CoglOnscreen" title="CoglOnscreen"><span class="type">CoglOnscreen</span></a> framebuffer</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>id</code></em> :</span></p></td>
<td>An identifier returned from <a class="link" href="cogl-2.0-experimental-CoglOnscreen---The-Onscreen-Framebuffer-Interface.html#cogl-onscreen-add-swap-buffers-callback" title="cogl_onscreen_add_swap_buffers_callback ()"><code class="function">cogl_onscreen_add_swap_buffers_callback()</code></a>
</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.10</p>
<p class="stability">Stability Level: Unstable</p>
</div>
</div>
</div>
<div class="footer">
<hr>
          Generated by GTK-Doc V1.18.1</div>
</body>
</html>